diff --git a/gcc/graphite-sese-to-poly.c b/gcc/graphite-sese-to-poly.c
index 0bc4433..439a069 100644
--- a/gcc/graphite-sese-to-poly.c
+++ b/gcc/graphite-sese-to-poly.c
@@ -80,7 +80,7 @@ tree_int_to_gmp (tree t, mpz_t res)
    loop.  */
 
 static size_t
-phi_arg_in_outermost_loop (gimple phi)
+phi_arg_in_outermost_loop (gimple *phi)
 {
   loop_p loop = gimple_bb (phi)->loop_father;
   size_t i, res = 0;
@@ -101,11 +101,11 @@ phi_arg_in_outermost_loop (gimple phi)
 static void
 remove_simple_copy_phi (gimple_stmt_iterator *psi)
 {
-  gimple phi = gsi_stmt (*psi);
+  gimple *phi = gsi_stmt (*psi);
   tree res = gimple_phi_result (phi);
   size_t entry = phi_arg_in_outermost_loop (phi);
   tree init = gimple_phi_arg_def (phi, entry);
-  gimple stmt = gimple_build_assign (res, init);
+  gimple *stmt = gimple_build_assign (res, init);
   edge e = gimple_phi_arg_edge (phi, entry);
 
   remove_phi_node (psi, false);
@@ -118,14 +118,14 @@ remove_simple_copy_phi (gimple_stmt_iterator *psi)
 static void
 remove_invariant_phi (sese region, gimple_stmt_iterator *psi)
 {
-  gimple phi = gsi_stmt (*psi);
+  gimple *phi = gsi_stmt (*psi);
   loop_p loop = loop_containing_stmt (phi);
   tree res = gimple_phi_result (phi);
   tree scev = scalar_evolution_in_region (region, loop, res);
   size_t entry = phi_arg_in_outermost_loop (phi);
   edge e = gimple_phi_arg_edge (phi, entry);
   tree var;
-  gimple stmt;
+  gimple *stmt;
   gimple_seq stmts = NULL;
 
   if (tree_contains_chrecs (scev, NULL))
@@ -144,7 +144,7 @@ remove_invariant_phi (sese region, gimple_stmt_iterator *psi)
 /* Returns true when the phi node at PSI is of the form "a = phi (a, x)".  */
 
 static inline bool
-simple_copy_phi_p (gimple phi)
+simple_copy_phi_p (gimple *phi)
 {
   tree res;
 
@@ -164,7 +164,7 @@ static bool
 reduction_phi_p (sese region, gimple_stmt_iterator *psi)
 {
   loop_p loop;
-  gimple phi = gsi_stmt (*psi);
+  gimple *phi = gsi_stmt (*psi);
   tree res = gimple_phi_result (phi);
 
   loop = loop_containing_stmt (phi);
@@ -314,7 +314,7 @@ try_generate_gimple_bb (scop_p scop, basic_block bb)
 
   for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
     {
-      gimple stmt = gsi_stmt (gsi);
+      gimple *stmt = gsi_stmt (gsi);
       loop_p loop;
 
       if (is_gimple_debug (stmt))
@@ -914,7 +914,7 @@ find_params_in_bb (sese region, gimple_bb_p gbb)
   int i;
   unsigned j;
   data_reference_p dr;
-  gimple stmt;
+  gimple *stmt;
   loop_p loop = GBB_BB (gbb)->loop_father;
 
   /* Find parameters in the access functions of data references.  */
@@ -1118,7 +1118,7 @@ create_pw_aff_from_tree (poly_bb_p pbb, tree t)
    inequalities.  */
 
 static void
-add_condition_to_pbb (poly_bb_p pbb, gimple stmt, enum tree_code code)
+add_condition_to_pbb (poly_bb_p pbb, gimple *stmt, enum tree_code code)
 {
   isl_pw_aff *lhs = create_pw_aff_from_tree (pbb, gimple_cond_lhs (stmt));
   isl_pw_aff *rhs = create_pw_aff_from_tree (pbb, gimple_cond_rhs (stmt));
@@ -1167,7 +1167,7 @@ static void
 add_conditions_to_domain (poly_bb_p pbb)
 {
   unsigned int i;
-  gimple stmt;
+  gimple *stmt;
   gimple_bb_p gbb = PBB_BLACK_BOX (pbb);
 
   if (GBB_CONDITIONS (gbb).is_empty ())
@@ -1214,14 +1214,14 @@ add_conditions_to_constraints (scop_p scop)
    edge between BB and its predecessor is not a loop exit edge, and
    the last statement of the single predecessor is a COND_EXPR.  */
 
-static gimple
+static gimple *
 single_pred_cond_non_loop_exit (basic_block bb)
 {
   if (single_pred_p (bb))
     {
       edge e = single_pred_edge (bb);
       basic_block pred = e->src;
-      gimple stmt;
+      gimple *stmt;
 
       if (loop_depth (pred->loop_father) > loop_depth (bb->loop_father))
 	return NULL;
@@ -1244,7 +1244,7 @@ public:
   virtual void after_dom_children (basic_block);
 
 private:
-  auto_vec<gimple, 3> m_conditions, m_cases;
+  auto_vec<gimple *, 3> m_conditions, m_cases;
   sese m_region;
 };
 
@@ -1260,7 +1260,7 @@ void
 sese_dom_walker::before_dom_children (basic_block bb)
 {
   gimple_bb_p gbb;
-  gimple stmt;
+  gimple *stmt;
 
   if (!bb_in_sese_p (bb, m_region))
     return;
@@ -1931,7 +1931,7 @@ build_scop_drs (scop_p scop)
 /* Return a gsi at the position of the phi node STMT.  */
 
 static gimple_stmt_iterator
-gsi_for_phi_node (gimple stmt)
+gsi_for_phi_node (gimple *stmt)
 {
   gimple_stmt_iterator psi;
   basic_block bb = gimple_bb (stmt);
@@ -1948,11 +1948,11 @@ gsi_for_phi_node (gimple stmt)
    GBB_DATA_REFS vector of BB.  */
 
 static void
-analyze_drs_in_stmts (scop_p scop, basic_block bb, vec<gimple> stmts)
+analyze_drs_in_stmts (scop_p scop, basic_block bb, vec<gimple *> stmts)
 {
   loop_p nest;
   gimple_bb_p gbb;
-  gimple stmt;
+  gimple *stmt;
   int i;
   sese region = SCOP_REGION (scop);
 
@@ -1983,11 +1983,11 @@ analyze_drs_in_stmts (scop_p scop, basic_block bb, vec<gimple> stmts)
    on STMTS.  */
 
 static void
-insert_stmts (scop_p scop, gimple stmt, gimple_seq stmts,
+insert_stmts (scop_p scop, gimple *stmt, gimple_seq stmts,
 	      gimple_stmt_iterator insert_gsi)
 {
   gimple_stmt_iterator gsi;
-  auto_vec<gimple, 3> x;
+  auto_vec<gimple *, 3> x;
 
   gimple_seq_add_stmt (&stmts, stmt);
   for (gsi = gsi_start (stmts); !gsi_end_p (gsi); gsi_next (&gsi))
@@ -2000,13 +2000,13 @@ insert_stmts (scop_p scop, gimple stmt, gimple_seq stmts,
 /* Insert the assignment "RES := EXPR" just after AFTER_STMT.  */
 
 static void
-insert_out_of_ssa_copy (scop_p scop, tree res, tree expr, gimple after_stmt)
+insert_out_of_ssa_copy (scop_p scop, tree res, tree expr, gimple *after_stmt)
 {
   gimple_seq stmts;
   gimple_stmt_iterator gsi;
   tree var = force_gimple_operand (expr, &stmts, true, NULL_TREE);
-  gimple stmt = gimple_build_assign (unshare_expr (res), var);
-  auto_vec<gimple, 3> x;
+  gimple *stmt = gimple_build_assign (unshare_expr (res), var);
+  auto_vec<gimple *, 3> x;
 
   gimple_seq_add_stmt (&stmts, stmt);
   for (gsi = gsi_start (stmts); !gsi_end_p (gsi); gsi_next (&gsi))
@@ -2059,9 +2059,9 @@ insert_out_of_ssa_copy_on_edge (scop_p scop, edge e, tree res, tree expr)
   gimple_stmt_iterator gsi;
   gimple_seq stmts = NULL;
   tree var = force_gimple_operand (expr, &stmts, true, NULL_TREE);
-  gimple stmt = gimple_build_assign (unshare_expr (res), var);
+  gimple *stmt = gimple_build_assign (unshare_expr (res), var);
   basic_block bb;
-  auto_vec<gimple, 3> x;
+  auto_vec<gimple *, 3> x;
 
   gimple_seq_add_stmt (&stmts, stmt);
   for (gsi = gsi_start (stmts); !gsi_end_p (gsi); gsi_next (&gsi))
@@ -2097,7 +2097,7 @@ create_zero_dim_array (tree var, const char *base_name)
 /* Returns true when PHI is a loop close phi node.  */
 
 static bool
-scalar_close_phi_node_p (gimple phi)
+scalar_close_phi_node_p (gimple *phi)
 {
   if (gimple_code (phi) != GIMPLE_PHI
       || virtual_operand_p (gimple_phi_result (phi)))
@@ -2116,7 +2116,7 @@ static void
 propagate_expr_outside_region (tree def, tree expr, sese region)
 {
   imm_use_iterator imm_iter;
-  gimple use_stmt;
+  gimple *use_stmt;
   gimple_seq stmts;
   bool replaced_once = false;
 
@@ -2154,12 +2154,12 @@ static void
 rewrite_close_phi_out_of_ssa (scop_p scop, gimple_stmt_iterator *psi)
 {
   sese region = SCOP_REGION (scop);
-  gimple phi = gsi_stmt (*psi);
+  gimple *phi = gsi_stmt (*psi);
   tree res = gimple_phi_result (phi);
   basic_block bb = gimple_bb (phi);
   gimple_stmt_iterator gsi = gsi_after_labels (bb);
   tree arg = gimple_phi_arg_def (phi, 0);
-  gimple stmt;
+  gimple *stmt;
 
   /* Note that loop close phi nodes should have a single argument
      because we translated the representation into a canonical form
@@ -2235,11 +2235,11 @@ static void
 rewrite_phi_out_of_ssa (scop_p scop, gimple_stmt_iterator *psi)
 {
   size_t i;
-  gimple phi = gsi_stmt (*psi);
+  gimple *phi = gsi_stmt (*psi);
   basic_block bb = gimple_bb (phi);
   tree res = gimple_phi_result (phi);
   tree zero_dim_array = create_zero_dim_array (res, "phi_out_of_ssa");
-  gimple stmt;
+  gimple *stmt;
 
   for (i = 0; i < gimple_phi_num_args (phi); i++)
     {
@@ -2269,9 +2269,9 @@ static void
 rewrite_degenerate_phi (gimple_stmt_iterator *psi)
 {
   tree rhs;
-  gimple stmt;
+  gimple *stmt;
   gimple_stmt_iterator gsi;
-  gimple phi = gsi_stmt (*psi);
+  gimple *phi = gsi_stmt (*psi);
   tree res = gimple_phi_result (phi);
   basic_block bb;
 
@@ -2299,7 +2299,7 @@ rewrite_reductions_out_of_ssa (scop_p scop)
     if (bb_in_sese_p (bb, region))
       for (psi = gsi_start_phis (bb); !gsi_end_p (psi);)
 	{
-	  gimple phi = gsi_stmt (psi);
+	  gimple *phi = gsi_stmt (psi);
 
 	  if (virtual_operand_p (gimple_phi_result (phi)))
 	    {
@@ -2329,9 +2329,9 @@ rewrite_reductions_out_of_ssa (scop_p scop)
 
 static void
 rewrite_cross_bb_scalar_dependence (scop_p scop, tree zero_dim_array,
-				    tree def, gimple use_stmt)
+				    tree def, gimple *use_stmt)
 {
-  gimple name_stmt;
+  gimple *name_stmt;
   tree name;
   ssa_op_iter iter;
   use_operand_p use_p;
@@ -2356,14 +2356,14 @@ rewrite_cross_bb_scalar_dependence (scop_p scop, tree zero_dim_array,
    SCOP.  */
 
 static void
-handle_scalar_deps_crossing_scop_limits (scop_p scop, tree def, gimple stmt)
+handle_scalar_deps_crossing_scop_limits (scop_p scop, tree def, gimple *stmt)
 {
   tree var = create_tmp_reg (TREE_TYPE (def), NULL);
   tree new_name = make_ssa_name (var, stmt);
   bool needs_copy = false;
   use_operand_p use_p;
   imm_use_iterator imm_iter;
-  gimple use_stmt;
+  gimple *use_stmt;
   sese region = SCOP_REGION (scop);
 
   FOR_EACH_IMM_USE_STMT (use_stmt, imm_iter, def)
@@ -2384,7 +2384,7 @@ handle_scalar_deps_crossing_scop_limits (scop_p scop, tree def, gimple stmt)
      arrays everywhere else.  */
   if (needs_copy)
     {
-      gimple assign = gimple_build_assign (new_name, def);
+      gimple *assign = gimple_build_assign (new_name, def);
       gimple_stmt_iterator psi = gsi_after_labels (SESE_EXIT (region)->dest);
 
       update_stmt (assign);
@@ -2400,12 +2400,12 @@ static bool
 rewrite_cross_bb_scalar_deps (scop_p scop, gimple_stmt_iterator *gsi)
 {
   sese region = SCOP_REGION (scop);
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
   imm_use_iterator imm_iter;
   tree def;
   basic_block def_bb;
   tree zero_dim_array = NULL_TREE;
-  gimple use_stmt;
+  gimple *use_stmt;
   bool res = false;
 
   switch (gimple_code (stmt))
@@ -2540,7 +2540,7 @@ nb_data_writes_in_bb (basic_block bb)
    polyhedral form.  */
 
 static edge
-split_pbb (scop_p scop, poly_bb_p pbb, basic_block bb, gimple stmt)
+split_pbb (scop_p scop, poly_bb_p pbb, basic_block bb, gimple *stmt)
 {
   edge e1 = split_block (bb, stmt);
   new_pbb_from_pbb (scop, pbb, e1->dest);
@@ -2551,7 +2551,7 @@ split_pbb (scop_p scop, poly_bb_p pbb, basic_block bb, gimple stmt)
    statements for which we want to ignore data dependences.  */
 
 static basic_block
-split_reduction_stmt (scop_p scop, gimple stmt)
+split_reduction_stmt (scop_p scop, gimple *stmt)
 {
   basic_block bb = gimple_bb (stmt);
   poly_bb_p pbb = pbb_from_bb (bb);
@@ -2600,7 +2600,7 @@ split_reduction_stmt (scop_p scop, gimple stmt)
 /* Return true when stmt is a reduction operation.  */
 
 static inline bool
-is_reduction_operation_p (gimple stmt)
+is_reduction_operation_p (gimple *stmt)
 {
   enum tree_code code;
 
@@ -2615,7 +2615,7 @@ is_reduction_operation_p (gimple stmt)
 /* Returns true when PHI contains an argument ARG.  */
 
 static bool
-phi_contains_arg (gimple phi, tree arg)
+phi_contains_arg (gimple *phi, tree arg)
 {
   size_t i;
 
@@ -2628,10 +2628,10 @@ phi_contains_arg (gimple phi, tree arg)
 
 /* Return a loop phi node that corresponds to a reduction containing LHS.  */
 
-static gimple
+static gimple *
 follow_ssa_with_commutative_ops (tree arg, tree lhs)
 {
-  gimple stmt;
+  gimple *stmt;
 
   if (TREE_CODE (arg) != SSA_NAME)
     return NULL;
@@ -2657,7 +2657,7 @@ follow_ssa_with_commutative_ops (tree arg, tree lhs)
 
   if (is_reduction_operation_p (stmt))
     {
-      gimple res = follow_ssa_with_commutative_ops (gimple_assign_rhs1 (stmt), lhs);
+      gimple *res = follow_ssa_with_commutative_ops (gimple_assign_rhs1 (stmt), lhs);
 
       return res ? res :
 	follow_ssa_with_commutative_ops (gimple_assign_rhs2 (stmt), lhs);
@@ -2669,12 +2669,12 @@ follow_ssa_with_commutative_ops (tree arg, tree lhs)
 /* Detect commutative and associative scalar reductions starting at
    the STMT.  Return the phi node of the reduction cycle, or NULL.  */
 
-static gimple
-detect_commutative_reduction_arg (tree lhs, gimple stmt, tree arg,
-				  vec<gimple> *in,
-				  vec<gimple> *out)
+static gimple *
+detect_commutative_reduction_arg (tree lhs, gimple *stmt, tree arg,
+				  vec<gimple *> *in,
+				  vec<gimple *> *out)
 {
-  gimple phi = follow_ssa_with_commutative_ops (arg, lhs);
+  gimple *phi = follow_ssa_with_commutative_ops (arg, lhs);
 
   if (!phi)
     return NULL;
@@ -2687,9 +2687,9 @@ detect_commutative_reduction_arg (tree lhs, gimple stmt, tree arg,
 /* Detect commutative and associative scalar reductions starting at
    STMT.  Return the phi node of the reduction cycle, or NULL.  */
 
-static gimple
-detect_commutative_reduction_assign (gimple stmt, vec<gimple> *in,
-				     vec<gimple> *out)
+static gimple *
+detect_commutative_reduction_assign (gimple *stmt, vec<gimple *> *in,
+				     vec<gimple *> *out)
 {
   tree lhs = gimple_assign_lhs (stmt);
 
@@ -2700,7 +2700,7 @@ detect_commutative_reduction_assign (gimple stmt, vec<gimple> *in,
 
   if (is_reduction_operation_p (stmt))
     {
-      gimple res = detect_commutative_reduction_arg (lhs, stmt,
+      gimple *res = detect_commutative_reduction_arg (lhs, stmt,
 						     gimple_assign_rhs1 (stmt),
 						     in, out);
       return res ? res
@@ -2714,10 +2714,10 @@ detect_commutative_reduction_assign (gimple stmt, vec<gimple> *in,
 
 /* Return a loop phi node that corresponds to a reduction containing LHS.  */
 
-static gimple
+static gimple *
 follow_inital_value_to_phi (tree arg, tree lhs)
 {
-  gimple stmt;
+  gimple *stmt;
 
   if (!arg || TREE_CODE (arg) != SSA_NAME)
     return NULL;
@@ -2736,7 +2736,7 @@ follow_inital_value_to_phi (tree arg, tree lhs)
    from outside the loop.  */
 
 static edge
-edge_initial_value_for_loop_phi (gimple phi)
+edge_initial_value_for_loop_phi (gimple *phi)
 {
   size_t i;
 
@@ -2756,7 +2756,7 @@ edge_initial_value_for_loop_phi (gimple phi)
    from outside the loop.  */
 
 static tree
-initial_value_for_loop_phi (gimple phi)
+initial_value_for_loop_phi (gimple *phi)
 {
   size_t i;
 
@@ -2776,7 +2776,7 @@ initial_value_for_loop_phi (gimple phi)
    LOOP_PHI.  */
 
 static bool
-used_outside_reduction (tree def, gimple loop_phi)
+used_outside_reduction (tree def, gimple *loop_phi)
 {
   use_operand_p use_p;
   imm_use_iterator imm_iter;
@@ -2785,7 +2785,7 @@ used_outside_reduction (tree def, gimple loop_phi)
   /* In LOOP, DEF should be used only in LOOP_PHI.  */
   FOR_EACH_IMM_USE_FAST (use_p, imm_iter, def)
     {
-      gimple stmt = USE_STMT (use_p);
+      gimple *stmt = USE_STMT (use_p);
 
       if (stmt != loop_phi
 	  && !is_gimple_debug (stmt)
@@ -2800,13 +2800,13 @@ used_outside_reduction (tree def, gimple loop_phi)
    the SCOP starting at the loop closed phi node STMT.  Return the phi
    node of the reduction cycle, or NULL.  */
 
-static gimple
-detect_commutative_reduction (scop_p scop, gimple stmt, vec<gimple> *in,
-			      vec<gimple> *out)
+static gimple *
+detect_commutative_reduction (scop_p scop, gimple *stmt, vec<gimple *> *in,
+			      vec<gimple *> *out)
 {
   if (scalar_close_phi_node_p (stmt))
     {
-      gimple def, loop_phi, phi, close_phi = stmt;
+      gimple *def, *loop_phi, *phi, *close_phi = stmt;
       tree init, lhs, arg = gimple_phi_arg_def (close_phi, 0);
 
       if (TREE_CODE (arg) != SSA_NAME)
@@ -2846,10 +2846,10 @@ detect_commutative_reduction (scop_p scop, gimple stmt, vec<gimple> *in,
 
 static void
 translate_scalar_reduction_to_array_for_stmt (scop_p scop, tree red,
-					      gimple stmt, gimple loop_phi)
+					      gimple *stmt, gimple *loop_phi)
 {
   tree res = gimple_phi_result (loop_phi);
-  gimple assign = gimple_build_assign (res, unshare_expr (red));
+  gimple *assign = gimple_build_assign (res, unshare_expr (red));
   gimple_stmt_iterator gsi;
 
   insert_stmts (scop, assign, NULL, gsi_after_labels (gimple_bb (loop_phi)));
@@ -2864,15 +2864,15 @@ translate_scalar_reduction_to_array_for_stmt (scop_p scop, tree red,
    the PHI_RESULT.  */
 
 static void
-remove_phi (gimple phi)
+remove_phi (gimple *phi)
 {
   imm_use_iterator imm_iter;
   tree def;
   use_operand_p use_p;
   gimple_stmt_iterator gsi;
-  auto_vec<gimple, 3> update;
+  auto_vec<gimple *, 3> update;
   unsigned int i;
-  gimple stmt;
+  gimple *stmt;
 
   def = PHI_RESULT (phi);
   FOR_EACH_IMM_USE_FAST (use_p, imm_iter, def)
@@ -2902,7 +2902,7 @@ dr_indices_valid_in_loop (tree ref ATTRIBUTE_UNUSED, tree *index, void *data)
 {
   loop_p loop;
   basic_block header, def_bb;
-  gimple stmt;
+  gimple *stmt;
 
   if (TREE_CODE (*index) != SSA_NAME)
     return true;
@@ -2927,11 +2927,11 @@ dr_indices_valid_in_loop (tree ref ATTRIBUTE_UNUSED, tree *index, void *data)
    NULL_TREE.  */
 
 static tree
-close_phi_written_to_memory (gimple close_phi)
+close_phi_written_to_memory (gimple *close_phi)
 {
   imm_use_iterator imm_iter;
   use_operand_p use_p;
-  gimple stmt;
+  gimple *stmt;
   tree res, def = gimple_phi_result (close_phi);
 
   FOR_EACH_IMM_USE_FAST (use_p, imm_iter, def)
@@ -2979,20 +2979,20 @@ close_phi_written_to_memory (gimple close_phi)
 
 static void
 translate_scalar_reduction_to_array (scop_p scop,
-				     vec<gimple> in,
-				     vec<gimple> out)
+				     vec<gimple *> in,
+				     vec<gimple *> out)
 {
-  gimple loop_phi;
+  gimple *loop_phi;
   unsigned int i = out.length () - 1;
   tree red = close_phi_written_to_memory (out[i]);
 
   FOR_EACH_VEC_ELT (in, i, loop_phi)
     {
-      gimple close_phi = out[i];
+      gimple *close_phi = out[i];
 
       if (i == 0)
 	{
-	  gimple stmt = loop_phi;
+	  gimple *stmt = loop_phi;
 	  basic_block bb = split_reduction_stmt (scop, stmt);
 	  poly_bb_p pbb = pbb_from_bb (bb);
 	  PBB_IS_REDUCTION (pbb) = true;
@@ -3025,11 +3025,11 @@ translate_scalar_reduction_to_array (scop_p scop,
 
 static bool
 rewrite_commutative_reductions_out_of_ssa_close_phi (scop_p scop,
-						     gimple close_phi)
+						     gimple *close_phi)
 {
   bool res;
-  auto_vec<gimple, 10> in;
-  auto_vec<gimple, 10> out;
+  auto_vec<gimple *, 10> in;
+  auto_vec<gimple *, 10> out;
 
   detect_commutative_reduction (scop, close_phi, &in, &out);
   res = in.length () > 1;
@@ -3107,7 +3107,7 @@ scop_ivs_can_be_represented (scop_p scop)
       for (psi = gsi_start_phis (loop->header);
 	   !gsi_end_p (psi); gsi_next (&psi))
 	{
-	  gimple phi = gsi_stmt (psi);
+	  gimple *phi = gsi_stmt (psi);
 	  tree res = PHI_RESULT (phi);
 	  tree type = TREE_TYPE (res);
 
diff --git a/gcc/internal-fn.c b/gcc/internal-fn.c
index 68b2b66..ef935ff 100644
--- a/gcc/internal-fn.c
+++ b/gcc/internal-fn.c
@@ -76,7 +76,7 @@ get_multi_vector_move (tree array_type, convert_optab optab)
 /* Expand LOAD_LANES call STMT.  */
 
 static void
-expand_LOAD_LANES (gimple stmt)
+expand_LOAD_LANES (gimple *stmt)
 {
   struct expand_operand ops[2];
   tree type, lhs, rhs;
@@ -100,7 +100,7 @@ expand_LOAD_LANES (gimple stmt)
 /* Expand STORE_LANES call STMT.  */
 
 static void
-expand_STORE_LANES (gimple stmt)
+expand_STORE_LANES (gimple *stmt)
 {
   struct expand_operand ops[2];
   tree type, lhs, rhs;
@@ -122,7 +122,7 @@ expand_STORE_LANES (gimple stmt)
 }
 
 static void
-expand_ANNOTATE (gimple stmt ATTRIBUTE_UNUSED)
+expand_ANNOTATE (gimple *stmt ATTRIBUTE_UNUSED)
 {
   gcc_unreachable ();
 }
@@ -130,7 +130,7 @@ expand_ANNOTATE (gimple stmt ATTRIBUTE_UNUSED)
 /* This should get expanded in adjust_simduid_builtins.  */
 
 static void
-expand_GOMP_SIMD_LANE (gimple stmt ATTRIBUTE_UNUSED)
+expand_GOMP_SIMD_LANE (gimple *stmt ATTRIBUTE_UNUSED)
 {
   gcc_unreachable ();
 }
@@ -138,7 +138,7 @@ expand_GOMP_SIMD_LANE (gimple stmt ATTRIBUTE_UNUSED)
 /* This should get expanded in adjust_simduid_builtins.  */
 
 static void
-expand_GOMP_SIMD_VF (gimple stmt ATTRIBUTE_UNUSED)
+expand_GOMP_SIMD_VF (gimple *stmt ATTRIBUTE_UNUSED)
 {
   gcc_unreachable ();
 }
@@ -146,7 +146,7 @@ expand_GOMP_SIMD_VF (gimple stmt ATTRIBUTE_UNUSED)
 /* This should get expanded in adjust_simduid_builtins.  */
 
 static void
-expand_GOMP_SIMD_LAST_LANE (gimple stmt ATTRIBUTE_UNUSED)
+expand_GOMP_SIMD_LAST_LANE (gimple *stmt ATTRIBUTE_UNUSED)
 {
   gcc_unreachable ();
 }
@@ -154,7 +154,7 @@ expand_GOMP_SIMD_LAST_LANE (gimple stmt ATTRIBUTE_UNUSED)
 /* This should get expanded in the sanopt pass.  */
 
 static void
-expand_UBSAN_NULL (gimple stmt ATTRIBUTE_UNUSED)
+expand_UBSAN_NULL (gimple *stmt ATTRIBUTE_UNUSED)
 {
   gcc_unreachable ();
 }
@@ -163,7 +163,7 @@ expand_UBSAN_NULL (gimple stmt ATTRIBUTE_UNUSED)
    CODE says whether the operation is +, or -.  */
 
 void
-ubsan_expand_si_overflow_addsub_check (tree_code code, gimple stmt)
+ubsan_expand_si_overflow_addsub_check (tree_code code, gimple *stmt)
 {
   rtx res, op0, op1;
   tree lhs, fn, arg0, arg1;
@@ -311,7 +311,7 @@ ubsan_expand_si_overflow_addsub_check (tree_code code, gimple stmt)
 /* Add negate overflow checking to the statement STMT.  */
 
 void
-ubsan_expand_si_overflow_neg_check (gimple stmt)
+ubsan_expand_si_overflow_neg_check (gimple *stmt)
 {
   rtx res, op1;
   tree lhs, fn, arg1;
@@ -387,7 +387,7 @@ ubsan_expand_si_overflow_neg_check (gimple stmt)
 /* Add mul overflow checking to the statement STMT.  */
 
 void
-ubsan_expand_si_overflow_mul_check (gimple stmt)
+ubsan_expand_si_overflow_mul_check (gimple *stmt)
 {
   rtx res, op0, op1;
   tree lhs, fn, arg0, arg1;
@@ -780,7 +780,7 @@ ubsan_expand_si_overflow_mul_check (gimple stmt)
 /* Expand UBSAN_CHECK_ADD call STMT.  */
 
 static void
-expand_UBSAN_CHECK_ADD (gimple stmt)
+expand_UBSAN_CHECK_ADD (gimple *stmt)
 {
   ubsan_expand_si_overflow_addsub_check (PLUS_EXPR, stmt);
 }
@@ -788,7 +788,7 @@ expand_UBSAN_CHECK_ADD (gimple stmt)
 /* Expand UBSAN_CHECK_SUB call STMT.  */
 
 static void
-expand_UBSAN_CHECK_SUB (gimple stmt)
+expand_UBSAN_CHECK_SUB (gimple *stmt)
 {
   if (integer_zerop (gimple_call_arg (stmt, 0)))
     ubsan_expand_si_overflow_neg_check (stmt);
@@ -799,7 +799,7 @@ expand_UBSAN_CHECK_SUB (gimple stmt)
 /* Expand UBSAN_CHECK_MUL call STMT.  */
 
 static void
-expand_UBSAN_CHECK_MUL (gimple stmt)
+expand_UBSAN_CHECK_MUL (gimple *stmt)
 {
   ubsan_expand_si_overflow_mul_check (stmt);
 }
@@ -807,13 +807,13 @@ expand_UBSAN_CHECK_MUL (gimple stmt)
 /* This should get folded in tree-vectorizer.c.  */
 
 static void
-expand_LOOP_VECTORIZED (gimple stmt ATTRIBUTE_UNUSED)
+expand_LOOP_VECTORIZED (gimple *stmt ATTRIBUTE_UNUSED)
 {
   gcc_unreachable ();
 }
 
 static void
-expand_MASK_LOAD (gimple stmt)
+expand_MASK_LOAD (gimple *stmt)
 {
   struct expand_operand ops[3];
   tree type, lhs, rhs, maskt;
@@ -838,7 +838,7 @@ expand_MASK_LOAD (gimple stmt)
 }
 
 static void
-expand_MASK_STORE (gimple stmt)
+expand_MASK_STORE (gimple *stmt)
 {
   struct expand_operand ops[3];
   tree type, lhs, rhs, maskt;
@@ -861,12 +861,12 @@ expand_MASK_STORE (gimple stmt)
 }
 
 static void
-expand_ABNORMAL_DISPATCHER (gimple)
+expand_ABNORMAL_DISPATCHER (gimple *)
 {
 }
 
 static void
-expand_BUILTIN_EXPECT (gimple stmt)
+expand_BUILTIN_EXPECT (gimple *stmt)
 {
   /* When guessing was done, the hints should be already stripped away.  */
   gcc_assert (!flag_guess_branch_prob || optimize == 0 || seen_error ());
@@ -888,7 +888,7 @@ expand_BUILTIN_EXPECT (gimple stmt)
        expand_<NAME> (gimple stmt)
 
    where STMT is the statement that performs the call. */
-static void (*const internal_fn_expanders[]) (gimple) = {
+static void (*const internal_fn_expanders[]) (gimple *) = {
 #define DEF_INTERNAL_FN(CODE, FLAGS) expand_##CODE,
 #include "internal-fn.def"
 #undef DEF_INTERNAL_FN
@@ -898,7 +898,7 @@ static void (*const internal_fn_expanders[]) (gimple) = {
 /* Expand STMT, which is a call to internal function FN.  */
 
 void
-expand_internal_call (gimple stmt)
+expand_internal_call (gimple *stmt)
 {
   internal_fn_expanders[(int) gimple_call_internal_fn (stmt)] (stmt);
 }
diff --git a/gcc/internal-fn.h b/gcc/internal-fn.h
index 9c3215f..7e66088 100644
--- a/gcc/internal-fn.h
+++ b/gcc/internal-fn.h
@@ -48,6 +48,6 @@ internal_fn_flags (enum internal_fn fn)
   return internal_fn_flags_array[(int) fn];
 }
 
-extern void expand_internal_call (gimple);
+extern void expand_internal_call (gimple *);
 
 #endif
diff --git a/gcc/ipa-inline-analysis.c b/gcc/ipa-inline-analysis.c
index 2bb3759..db9fbf7 100644
--- a/gcc/ipa-inline-analysis.c
+++ b/gcc/ipa-inline-analysis.c
@@ -1493,7 +1493,7 @@ mark_modified (ao_ref *ao ATTRIBUTE_UNUSED, tree vdef ATTRIBUTE_UNUSED,
    parameter.  */
 
 static tree
-unmodified_parm_1 (gimple stmt, tree op)
+unmodified_parm_1 (gimple *stmt, tree op)
 {
   /* SSA_NAME referring to parm default def?  */
   if (TREE_CODE (op) == SSA_NAME
@@ -1519,7 +1519,7 @@ unmodified_parm_1 (gimple stmt, tree op)
    parameter.  Also traverse chains of SSA register assignments.  */
 
 static tree
-unmodified_parm (gimple stmt, tree op)
+unmodified_parm (gimple *stmt, tree op)
 {
   tree res = unmodified_parm_1 (stmt, op);
   if (res)
@@ -1542,7 +1542,7 @@ unmodified_parm (gimple stmt, tree op)
 
 static bool
 unmodified_parm_or_parm_agg_item (struct ipa_node_params *info,
-				  gimple stmt, tree op, int *index_p,
+				  gimple *stmt, tree op, int *index_p,
 				  struct agg_position_info *aggpos)
 {
   tree res = unmodified_parm_1 (stmt, op);
@@ -1583,7 +1583,7 @@ unmodified_parm_or_parm_agg_item (struct ipa_node_params *info,
    penalty wrappers.  */
 
 static int
-eliminated_by_inlining_prob (gimple stmt)
+eliminated_by_inlining_prob (gimple *stmt)
 {
   enum gimple_code code = gimple_code (stmt);
   enum tree_code rhs_code;
@@ -1716,14 +1716,14 @@ set_cond_stmt_execution_predicate (struct ipa_node_params *info,
 				   struct inline_summary *summary,
 				   basic_block bb)
 {
-  gimple last;
+  gimple *last;
   tree op;
   int index;
   struct agg_position_info aggpos;
   enum tree_code code, inverted_code;
   edge e;
   edge_iterator ei;
-  gimple set_stmt;
+  gimple *set_stmt;
   tree op2;
 
   last = last_stmt (bb);
@@ -1801,7 +1801,7 @@ set_switch_stmt_execution_predicate (struct ipa_node_params *info,
 				     struct inline_summary *summary,
 				     basic_block bb)
 {
-  gimple last;
+  gimple *last;
   tree op;
   int index;
   struct agg_position_info aggpos;
@@ -2002,7 +2002,7 @@ will_be_nonconstant_expr_predicate (struct ipa_node_params *info,
 static struct predicate
 will_be_nonconstant_predicate (struct ipa_node_params *info,
 			       struct inline_summary *summary,
-			       gimple stmt,
+			       gimple *stmt,
 			       vec<predicate_t> nonconstant_names)
 {
   struct predicate p = true_predicate ();
@@ -2089,7 +2089,7 @@ will_be_nonconstant_predicate (struct ipa_node_params *info,
 struct record_modified_bb_info
 {
   bitmap bb_set;
-  gimple stmt;
+  gimple *stmt;
 };
 
 /* Callback of walk_aliased_vdefs.  Records basic blocks where the value may be
@@ -2117,7 +2117,7 @@ record_modified (ao_ref *ao ATTRIBUTE_UNUSED, tree vdef, void *data)
    ought to be REG_BR_PROB_BASE / estimated_iters.  */
 
 static int
-param_change_prob (gimple stmt, int i)
+param_change_prob (gimple *stmt, int i)
 {
   tree op = gimple_call_arg (stmt, i);
   basic_block bb = gimple_bb (stmt);
@@ -2210,7 +2210,7 @@ phi_result_unknown_predicate (struct ipa_node_params *info,
   edge e;
   edge_iterator ei;
   basic_block first_bb = NULL;
-  gimple stmt;
+  gimple *stmt;
 
   if (single_pred_p (bb))
     {
@@ -2262,7 +2262,7 @@ phi_result_unknown_predicate (struct ipa_node_params *info,
    NONCONSTANT_NAMES, if possible.  */
 
 static void
-predicate_for_phi_result (struct inline_summary *summary, gimple phi,
+predicate_for_phi_result (struct inline_summary *summary, gimple *phi,
 			  struct predicate *p,
 			  vec<predicate_t> nonconstant_names)
 {
@@ -2325,14 +2325,14 @@ array_index_predicate (struct inline_summary *info,
    an impact on the earlier inlining.
    Here find this pattern and fix it up later.  */
 
-static gimple
+static gimple *
 find_foldable_builtin_expect (basic_block bb)
 {
   gimple_stmt_iterator bsi;
 
   for (bsi = gsi_start_bb (bb); !gsi_end_p (bsi); gsi_next (&bsi))
     {
-      gimple stmt = gsi_stmt (bsi);
+      gimple *stmt = gsi_stmt (bsi);
       if (gimple_call_builtin_p (stmt, BUILT_IN_EXPECT)
 	  || (is_gimple_call (stmt)
 	      && gimple_call_internal_p (stmt)
@@ -2341,7 +2341,7 @@ find_foldable_builtin_expect (basic_block bb)
           tree var = gimple_call_lhs (stmt);
           tree arg = gimple_call_arg (stmt, 0);
           use_operand_p use_p;
-          gimple use_stmt;
+          gimple *use_stmt;
           bool match = false;
           bool done = false;
 
@@ -2351,7 +2351,7 @@ find_foldable_builtin_expect (basic_block bb)
 
           while (TREE_CODE (arg) == SSA_NAME)
             {
-              gimple stmt_tmp = SSA_NAME_DEF_STMT (arg);
+              gimple *stmt_tmp = SSA_NAME_DEF_STMT (arg);
               if (!is_gimple_assign (stmt_tmp))
                 break;
               switch (gimple_assign_rhs_code (stmt_tmp))
@@ -2413,7 +2413,7 @@ clobber_only_eh_bb_p (basic_block bb, bool need_eh = true)
 
   for (; !gsi_end_p (gsi); gsi_prev (&gsi))
     {
-      gimple stmt = gsi_stmt (gsi);
+      gimple *stmt = gsi_stmt (gsi);
       if (is_gimple_debug (stmt))
 	continue;
       if (gimple_clobber_p (stmt))
@@ -2455,7 +2455,7 @@ estimate_function_body_sizes (struct cgraph_node *node, bool early)
   int nblocks, n;
   int *order;
   predicate array_index = true_predicate ();
-  gimple fix_builtin_expect_stmt;
+  gimple *fix_builtin_expect_stmt;
 
   info->conds = NULL;
   info->entry = NULL;
@@ -2548,7 +2548,7 @@ estimate_function_body_sizes (struct cgraph_node *node, bool early)
 
       for (bsi = gsi_start_bb (bb); !gsi_end_p (bsi); gsi_next (&bsi))
 	{
-	  gimple stmt = gsi_stmt (bsi);
+	  gimple *stmt = gsi_stmt (bsi);
 	  int this_size = estimate_num_insns (stmt, &eni_size_weights);
 	  int this_time = estimate_num_insns (stmt, &eni_time_weights);
 	  int prob;
@@ -2744,7 +2744,7 @@ estimate_function_body_sizes (struct cgraph_node *node, bool early)
 	      for (gsi = gsi_start_bb (body[i]); !gsi_end_p (gsi);
 		   gsi_next (&gsi))
 		{
-		  gimple stmt = gsi_stmt (gsi);
+		  gimple *stmt = gsi_stmt (gsi);
 		  affine_iv iv;
 		  ssa_op_iter iter;
 		  tree use;
diff --git a/gcc/ipa-inline.c b/gcc/ipa-inline.c
index 65e6533..34775fd 100644
--- a/gcc/ipa-inline.c
+++ b/gcc/ipa-inline.c
@@ -1731,9 +1731,9 @@ inline_small_functions (void)
 		   " Estimated badness is %i, frequency %.2f.\n",
 		   edge->caller->name (), edge->caller->order,
 		   flag_wpa ? "unknown"
-		   : gimple_filename ((const_gimple) edge->call_stmt),
+		   : gimple_filename ((const gimple *) edge->call_stmt),
 		   flag_wpa ? -1
-		   : gimple_lineno ((const_gimple) edge->call_stmt),
+		   : gimple_lineno ((const gimple *) edge->call_stmt),
 		   badness,
 		   edge->frequency / (double)CGRAPH_FREQ_BASE);
 	  if (edge->count)
diff --git a/gcc/ipa-profile.c b/gcc/ipa-profile.c
index 71bd61b..7e37e82 100644
--- a/gcc/ipa-profile.c
+++ b/gcc/ipa-profile.c
@@ -193,7 +193,7 @@ ipa_profile_generate_summary (void)
 	int size = 0;
         for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
 	  {
-	    gimple stmt = gsi_stmt (gsi);
+	    gimple *stmt = gsi_stmt (gsi);
 	    if (gimple_code (stmt) == GIMPLE_CALL
 		&& !gimple_call_fndecl (stmt))
 	      {
